#ifndef PERSONAGEM_H_
#define PERSONAGEM_H_
#include <allegro.h>
class Personagem {
    private:

        BITMAP *sprite[2][4];   /* Matriz de sprites para o personagem. Linha 0 = personagem virado p/ direita. Linha 1 = p/ esquerda.
                                   Linha 2 = personagem pulando p/ direita. Linha 3 = p/ esquerda. */
        bool direcao;           // O lado em que o sprite do personagem est virado.
        int animacao;           // Sequncia da animao do personagem.
        char lado;              // indica para que lado o personagem vai estar. 1 = direita; 2 = esquerda; 0 = no muda.
        int x;                  // Posio OX do personagem.
        int y;                  // Posio OY do personagem.
        int velocidade;         // Velocidade em pixeis per frames do personagem.
        int vidas;              // Quantidade de vidas extras do personagem.
        bool morto;             // indica se o personagem est vivo ou morto.
        int morto_counter;      // corresponde  durao do personagem morto.
        int direita;            // Boto para mover o personagem para direita.
        int esquerda;           // Boto para mover o personagem para esquerda.
        bool colisao;           // verifica se o personagem est no cho.

        void carregar_imagem (int);     // deve receber os valores 1 ou 2, correspondente ao nmero do jogador.
        void mover (BITMAP &buffer);                  // define a posio do personagem quando for desenhado.
        void desenhar (BITMAP &buffer); // desenha o personagem no buffer.
        void set_direcao (char);        // altera a direo em que a imagem estar virada
        void set_morto ();              // altera o estado do personagem para morto.
        void set_colisao ();            // altera o estado do personagem para colidindo.
        void set_morto_counter ();      // incrementa o tempo do personagem morto.
        int get_size_H ();              // retorna a altura da imagem.
        int get_size_W ();              // retorna a largura da imagem.
        int get_morto_counter ();       // retorna o tempo do personagem morto.
        bool get_direcao ();            // retorna a direo em que a imagem est virada.
        bool get_morto ();              // retorna o estado do personagem.
        char get_animacao ();           // retorna qual parte da animao da imagem deve ser no momento.
        BITMAP *get_sprite ();          // retorna a sprite a ser usada, de acordo com a direo e a animao correspondente.
    public:
        Personagem (int, int, int);     // os parmetros so os controles do personagem.
        ~Personagem ();
        void processar (BITMAP &buffer);// processar as funes mover() e desenhar().
        void set_vidas (int);           // altera a quantidade de vidas extras do personagem.
        int get_vidas ();               // retorna quantas vidas o personagem ainda possui.
        bool colisaoEsquerda (BITMAP &buffer);
        bool colisaoDireita (BITMAP &buffer);
        void colisaoCima (BITMAP &buffer);
        void resetarVidas();
};

#endif // PERSONAGEM_H_INCLUDED
