#include <iostream>
#include <allegro.h>
#include "Fase.h"
#include "Abertura.h"

using namespace std;

#define MAX_X 640
#define MAX_Y 480
#define V_MAX_X 0
#define V_MAX_Y 0
#define COLOR_BITS 32
#define VIDEO_CARD GFX_AUTODETECT_FULLSCREEN
#define DIGI_CARD DIGI_AUTODETECT
#define MIDI_CARD MIDI_AUTODETECT

//-------------------------------------------------------------------------
// FUNÇÕES PRINCIPAIS
int inicia(void);
void finaliza(void);
void principal(void);
void game_timer(void);
volatile long int counter = 0;
int FPS = 60;
int TBF = FPS/1000;

int main(int argc, char **argv)
{

	if (!inicia())
	{
		finaliza();
		return -1;
	}

	principal();

	finaliza();
	return 0;
}
END_OF_MAIN();

int inicia(void)
{

	allegro_init();

	install_keyboard();
	install_mouse();

	install_timer();

	srand((unsigned)time(NULL));

	set_color_depth(COLOR_BITS);

	if (set_gfx_mode(GFX_AUTODETECT, MAX_X, MAX_Y, V_MAX_X, V_MAX_Y) < 0){
		allegro_message("Erro ao inicializar o modo grafico");
		return (FALSE);
	}


	if (COLOR_BITS == 32)	set_alpha_blender(); // instala o canal alpha (funciona apenas em 32 bits)

////
//	if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) < 0)
//	{
//		allegro_message("Erro ao inicializar o som");
//		return (FALSE);
//	}


	return (TRUE);
}

void game_timer(){
    counter++;
}
END_OF_FUNCTION(game_timer);

void principal(void)
{
	// Declaração de variáveis
    bool flag = false;
    bool abertura = false;
	bool exit = false;
	int selecao;

    BITMAP *buffer;
    buffer = create_bitmap(640,480);
    BITMAP *cobertura;
    cobertura = create_bitmap(640,29);
    LOCK_VARIABLE(counter);
    LOCK_FUNCTION(game_timer);
    install_int(game_timer, 1000/FPS);
    int vel_control = 0;
    int contPassandoFase = 0;
    Fase *fase1;
    Fase *fase2;
    Player *p1;
    Player *p2;
    Fase *faseAtual;
    Abertura *open = new Abertura();

    // Loop do Jogo
    do
	{

	    if(counter >= vel_control){
            if(abertura == false)
            {
                selecao = open->selecao(buffer, abertura);
                clear(cobertura);
                abertura = true;
                if(selecao == 0)
                {
                	p1 = new Player(*buffer, *cobertura, 1);
                	fase1 = new Fase(*buffer, *cobertura, 1, 1, *p1, *p2);
                    fase2 = new Fase(*buffer, *cobertura, 1, 2, *p1, *p2);
                    faseAtual = fase1;
                }
                else if(selecao == 1)
                {
                    p1 = new Player(*buffer, *cobertura, 1);
                	p2 = new Player(*buffer, *cobertura, 2);
                    fase1 = new Fase(*buffer, *cobertura, 2, 1, *p1, *p2);
                    fase2 = new Fase(*buffer, *cobertura, 2, 2, *p1, *p2);
                    faseAtual = fase1;
                }
                else if(selecao == 3)
                {
                    exit = true;
                }
            }



            if(!exit){
                if(!faseAtual->passouFase()){
                    faseAtual->processar(flag);
                    if(faseAtual->deuGameOver()){
                    	BITMAP *gameOver = load_bitmap("./abertura/game_over.bmp", NULL);
                        while(!(key[KEY_ENTER] && !flag)){
                            draw_sprite(screen, gameOver, 0,0);
                            textprintf_ex(gameOver, font, 50,50, makecol(255,255,255), -1, "Mario: %d", p1->getPontos());
        					if(selecao == 1)
        						textprintf_ex(gameOver, font, 470,50, makecol(255,255,255), -1, "Peach: %d", p2->getPontos());
                        }

                        abertura = false;
                    }
                }else{
                	clear(cobertura);
                	//Acelera o cenário móvel quando passamos de fase
                    contPassandoFase++;
                    if(contPassandoFase < 250)
                        faseAtual->acelerarCenario(10);
                    else{
                        contPassandoFase = 0;
                         p1->resetarVidas();
                         if(selecao == 1)
	                         p2->resetarVidas();
                        if(faseAtual == fase2){
                        	BITMAP *finish;
                        	if(selecao == 0) // 1 player
                            	finish = load_bitmap("./abertura/finish_mario.bmp", NULL);
                            else if(selecao == 1){ //2 players
                            	int a = p1->getPontos();
                            	int b = p2->getPontos();
                            	if(a > b)
                            		finish = load_bitmap("./abertura/finish_mario.bmp", NULL);
                            	else if(a < b)
                            		finish = load_bitmap("./abertura/finish_peach.bmp", NULL);
                            	else
                            		finish = load_bitmap("./abertura/finish_draw.bmp", NULL);
                            }
                            textprintf_ex(finish, font, 50,50, makecol(0,0,0), -1, "Mario: %d", p1->getPontos());
        					if(selecao == 1)
        						textprintf_ex(finish, font, 470,50, makecol(0,0,0), -1, "Peach: %d", p2->getPontos());
                        	while(!(key[KEY_ENTER] && !flag)){
                            	draw_sprite(screen, finish, 0,0);
                        	}
                            abertura = false;
                        }else{
                            faseAtual = fase2;
                        }
                    }
                }

                if(key[KEY_P] && !flag){
                    while(key[KEY_P]);
                    while(true){
                        if(key[KEY_P])
                            break;
                    }
                }

                if(key[KEY_ESC] && !flag){
                    if(abertura == true){
                        abertura = false;
                    }else{
                        exit = true;
                    }
                }
                if(key[KEY_P] || key[KEY_ESC] || key[KEY_F5])
                    flag = true;
                else
                    flag = false;
                vel_control = counter + 1;
                blit(cobertura, screen, 0,0,0,0,640,29);
                blit(buffer, screen,0,-29,0,0,640,480);
                clear(buffer);

            }
        }
	}while(!exit);
	if(open != NULL){
		delete(open);
		open = 0;
	}
	destroy_bitmap(buffer);
	destroy_bitmap(cobertura);
}

void finaliza(void)
{
	remove_timer();
	remove_mouse();
	remove_sound();
	remove_keyboard();
	allegro_exit();
}
